package src.lib;

public class Utilities {

	final static int LONG_SIZE_CHR = 32; //in characters, not in Bits!
	final static int LONG_SIZE_BIT = 64;

	public static String SVNID = "$Id: Utilities.java 33274 2007-10-25 23:17:43Z afejes $";
	
	/**
	 * Returns the reverse compliment of a string
	 * 
	 * @param x
	 *            The string to RC
	 * @return The RC of the input string
	 * @author Anthony Fejes
	 */
	public static String reverseCompliment(String x) {

		int length = x.length();
		x = x.toUpperCase();
		
		StringBuffer sb = new StringBuffer("");
		
		for (int i = length-1; i>= 0; --i) {
			char c = x.charAt(i);
			if (c == 'A') {
				sb.append('T');
			} else if (c == 'C') {
				sb.append('G');
			} else if (c == 'G') {
				sb.append('C');
			} else if (c == 'T') {
				sb.append('A');
			} else {
				sb.append(c);
			}
		}
		return sb.toString();
	}


		
	/**
	 * Simple print function for Binary Long variables
	 * 
	 * @param s
	 *            String to be printed as an identifier
	 * @param l
	 *            Long to be printed in binary format
	 * @author http://www.java2s.com/Code/Java/Language-Basics/Usingthebitwiseoperators.htm
	 */
	public static void printBinaryLong(String s, long l) {
		System.out.println(s + ", long: " + l + ", binary: ");
		System.out.print("   ");
		for (int i = 63; i >= 0; i--) {
			if (((1L << i) & l) != 0) {
				System.out.print("1");
			} else {
				System.out.print("0");
			}
		}
		System.out.println();
	}
	
	
	/**
	 * Adaptation of printBinaryLong to return a string instead of printing it.
	 * 
	 * @param l
	 * @return A string giving the binary representation of the long value
	 *         provided
	 * @author Anthony Fejes
	 */
	public static String returnBinaryLong(long l) {
		StringBuffer sb = new StringBuffer("");
		for (int i = 63; i >= 0; i--) {
			if (((1L << i) & l) != 0) {
				sb.append("1");
			} else {
				sb.append("0");
			}
		}
		return sb.toString();
	}
	
	

	public static void test_reverseCompliment () {
		String A = "ACTTTGGGGGTACCACACTATA";
		String B = reverseCompliment(A);
		System.out.println(A);
		System.out.println(B);
	}
	
	public static String FormatNumberForPrinting (Double X) {
		String S = Double.toString(X);
		String S2 = "";
		int len = S.length();
		for (int q = 1; q <= ((len-1)/3); q++) {
			S2 = new StringBuffer(S).insert((len-(q*3)), ",").toString();
			S = S2;
		}
		return S;
	}
	

	public static String FormatNumberForPrinting (int X) {
		String S = Integer.toString(X);
		String S2 = "";
		int len = S.length();
		for (int q = 1; q <= ((len-1)/3); q++) {
			S2 = new StringBuffer(S).insert((len-(q*3)), ",").toString();
			S = S2;
		}
		return S;
	}

	/**
	 * 
	 * @param X  Number to format
	 * @param Y  Positions after decimal point
	 * @return
	 */
	public static String DecimalPoints(float X, int Y) {
		String S = Float.toString(X);
		int p = S.indexOf('.') + 1;;
		if ((p+Y) > S.length()) {
			return S;
		} else {
			return S.substring(0, (p+Y));
		}
	}
	
	/**
	 * Overloaded for floats and Doubles
	 * @param X  Number to format
	 * @param Y  Positions after decimal point
	 * @return
	 */
	public static String DecimalPoints(double X, int Y) {
		String S = Double.toString(X);
		int p = S.indexOf('.') + 1;
		if ((p+Y) > S.length()) {
			return S;
		} else {
			return S.substring(0, (p+Y));
		}
	}
	
 	
}
